-- creating a view for our joined data 
CREATE VIEW ALL_ORDERS_AND_THEIR_ITEMS AS
SELECT 
	bi.ID "BAKERY_ITEM_ID", bi.ITEM_TYPE, bi.PRICE, bi.MUFFIN_FLAVOR, bi.BREAD_TYPE, bi.COFFEE_ROAST, bi.COFFEE_SIZE,
	bo.ID "BAKERY_ORDER_ID", bo.CUSTOMER, bo.PHONE, bo.HAS_PAID, bo.ORDER_STATUS 
FROM BAKERY_ORDER bo 
LEFT OUTER JOIN BAKERY_ORDER_ITEM boi 
ON bo.ID = boi.ORDER_ID 
LEFT OUTER JOIN BAKERY_ITEM bi  
ON boi.ITEM_ID = bi.ID;

SELECT *
FROM ALL_ORDERS_AND_THEIR_ITEMS;

-- TAKING A LOOK AT MORE FUNCTIONS
SELECT MAX(ID)
FROM BAKERY_ITEM bi;

SELECT MAX(PRICE)
FROM BAKERY_ITEM bi;

SELECT MIN(PRICE)
FROM BAKERY_ITEM bi;

SELECT ROUND(AVG(PRICE),2) "Average Price"
FROM BAKERY_ITEM bi;

SELECT COUNT(ID)
FROM BAKERY_ITEM bi;

SELECT COUNT(ITEM_TYPE), ITEM_TYPE
FROM BAKERY_ORDER bo 
JOIN BAKERY_ORDER_ITEM boi 
ON bo.ID = boi.ORDER_ID 
JOIN BAKERY_ITEM bi 
ON boi.ITEM_ID = bi.ID
GROUP BY ITEM_TYPE;

SELECT COUNT(ITEM_TYPE), ITEM_TYPE
FROM ALL_ORDERS_AND_THEIR_ITEMS
GROUP BY ITEM_TYPE
HAVING ITEM_TYPE IS NOT NULL;

SELECT COUNT(ITEM_TYPE), ITEM_TYPE
FROM ALL_ORDERS_AND_THEIR_ITEMS
GROUP BY ITEM_TYPE
HAVING COUNT(ITEM_TYPE)>0;

-- CHECKING THE INVENTORY FOR PENDING ITEMS
SELECT COUNT(ITEM_TYPE), ITEM_TYPE
FROM ALL_ORDERS_AND_THEIR_ITEMS
WHERE ORDER_STATUS = 'PENDING'
GROUP BY ITEM_TYPE
HAVING ITEM_TYPE IS NOT NULL;


SELECT BAKERY_ORDER_ID, CUSTOMER, SUM(PRICE) "Pre tax total", ROUND(SUM(PRICE)*1.06,2) "post tax total"
FROM ALL_ORDERS_AND_THEIR_ITEMS
GROUP BY CUSTOMER, BAKERY_ORDER_ID;

CREATE VIEW ORDER_TOTALS AS 
SELECT BAKERY_ORDER_ID, CUSTOMER, SUM(PRICE) "Pre tax total", ROUND(SUM(PRICE)*1.06,2) "post tax total"
FROM ALL_ORDERS_AND_THEIR_ITEMS
GROUP BY CUSTOMER, BAKERY_ORDER_ID;

SELECT *
FROM ORDER_TOTALS;

-- USING A SUBQUERY - NESTING QUERIES
SELECT *
FROM BAKERY_ITEM bi 
WHERE PRICE = (
	SELECT MIN(PRICE)
	FROM BAKERY_ITEM bi2);


--  SET OPERATION - USING UNION TO COMBINE TWO COMPATABLE DATA SETS
SELECT CONCAT(MUFFIN_FLAVOR, ' MUFFIN') AS "ITEM", PRICE
FROM BAKERY_ITEM bi
WHERE ITEM_TYPE = 'MUFFIN'
UNION
SELECT CONCAT(BREAD_TYPE, ' BREAD'), PRICE 
FROM BAKERY_ITEM bi 
WHERE ITEM_TYPE = 'BREAD'
